/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.common.domain {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import flash.utils.IExternalizable;

    [Bindable]
    public class LocationPKBase implements IExternalizable {

        protected var _aisle:String;
        protected var _area:String;
        protected var _x:String;
        protected var _y:String;
        protected var _z:String;

        public function get aisle():String {
            return _aisle;
        }

        public function get area():String {
            return _area;
        }

        public function get x():String {
            return _x;
        }

        public function get y():String {
            return _y;
        }

        public function get z():String {
            return _z;
        }

        public function readExternal(input:IDataInput):void {
            _aisle = input.readObject() as String;
            _area = input.readObject() as String;
            _x = input.readObject() as String;
            _y = input.readObject() as String;
            _z = input.readObject() as String;
        }

        public function writeExternal(output:IDataOutput):void {
            output.writeObject(_aisle);
            output.writeObject(_area);
            output.writeObject(_x);
            output.writeObject(_y);
            output.writeObject(_z);
        }
    }
}