/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.common.domain {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import mx.collections.ListCollectionView;
    import org.granite.collections.IPersistentCollection;
    import org.granite.meta;
    import org.openwms.core.domain.AbstractEntity;
    import org.openwms.core.domain.DomainObject;

    use namespace meta;

    [Bindable]
    public class TransportUnitTypeBase extends AbstractEntity implements DomainObject {

        private var __initialized:Boolean = true;
        private var __detachedState:String = null;

        protected var _compatibility:String;
        protected var _description:String;
        protected var _height:int;
        protected var _id:Number;
        protected var _length:int;
        protected var _payload:Number;
        protected var _transportUnits:ListCollectionView;
        protected var _type:String;
        protected var _typePlacingRules:ListCollectionView;
        protected var _typeStackingRules:ListCollectionView;
        protected var _version:Number;
        protected var _weightMax:Number;
        protected var _weightTare:Number;
        protected var _width:int;

        override meta function isInitialized(name:String = null):Boolean {
            if (!name)
                return __initialized;

            var property:* = this[name];
            return (
                (!(property is TransportUnitType) || (property as TransportUnitType).meta::isInitialized()) &&
                (!(property is IPersistentCollection) || (property as IPersistentCollection).isInitialized())
            );
        }

        public function set compatibility(value:String):void {
            _compatibility = value;
        }
        public function get compatibility():String {
            return _compatibility;
        }

        public function set description(value:String):void {
            _description = value;
        }
        public function get description():String {
            return _description;
        }

        public function set height(value:int):void {
            _height = value;
        }
        public function get height():int {
            return _height;
        }

        public function get id():Number {
            return _id;
        }

        public function set length(value:int):void {
            _length = value;
        }
        public function get length():int {
            return _length;
        }

        public function set payload(value:Number):void {
            _payload = value;
        }
        public function get payload():Number {
            return _payload;
        }

        public function set transportUnits(value:ListCollectionView):void {
            _transportUnits = value;
        }
        public function get transportUnits():ListCollectionView {
            return _transportUnits;
        }

        public function set type(value:String):void {
            _type = value;
        }
        public function get type():String {
            return _type;
        }

        public function set typePlacingRules(value:ListCollectionView):void {
            _typePlacingRules = value;
        }
        public function get typePlacingRules():ListCollectionView {
            return _typePlacingRules;
        }

        public function set typeStackingRules(value:ListCollectionView):void {
            _typeStackingRules = value;
        }
        public function get typeStackingRules():ListCollectionView {
            return _typeStackingRules;
        }

        public function set version(value:Number):void {
            _version = value;
        }
        public function get version():Number {
            return _version;
        }

        public function set weightMax(value:Number):void {
            _weightMax = value;
        }
        public function get weightMax():Number {
            return _weightMax;
        }

        public function set weightTare(value:Number):void {
            _weightTare = value;
        }
        public function get weightTare():Number {
            return _weightTare;
        }

        public function set width(value:int):void {
            _width = value;
        }
        public function get width():int {
            return _width;
        }

        public function isNew():Boolean {
            return true;
        }

        override public function readExternal(input:IDataInput):void {
            __initialized = input.readObject() as Boolean;
            __detachedState = input.readObject() as String;
            if (meta::isInitialized()) {
                super.readExternal(input);
                _compatibility = input.readObject() as String;
                _description = input.readObject() as String;
                _height = input.readObject() as int;
                _id = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
                _length = input.readObject() as int;
                _payload = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
                _transportUnits = input.readObject() as ListCollectionView;
                _type = input.readObject() as String;
                _typePlacingRules = input.readObject() as ListCollectionView;
                _typeStackingRules = input.readObject() as ListCollectionView;
                _version = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
                _weightMax = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
                _weightTare = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
                _width = input.readObject() as int;
            }
            else {
                _id = function(o:*):Number { return (o is Number ? o as Number : Number.NaN) } (input.readObject());
            }
        }

        override public function writeExternal(output:IDataOutput):void {
            output.writeObject(__initialized);
            output.writeObject(__detachedState);
            if (meta::isInitialized()) {
                super.writeExternal(output);
                output.writeObject(_compatibility);
                output.writeObject(_description);
                output.writeObject(_height);
                output.writeObject(_id);
                output.writeObject(_length);
                output.writeObject(_payload);
                output.writeObject(_transportUnits);
                output.writeObject(_type);
                output.writeObject(_typePlacingRules);
                output.writeObject(_typeStackingRules);
                output.writeObject(_version);
                output.writeObject(_weightMax);
                output.writeObject(_weightTare);
                output.writeObject(_width);
            }
            else {
                output.writeObject(_id);
            }
        }
    }
}