/*
 * openwms.org, the Open Warehouse Management System.
 *
 * This file is part of openwms.org.
 *
 * openwms.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * openwms.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software. If not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.openwms.common.domain.values {

    import flash.utils.IDataInput;
    import flash.utils.IDataOutput;
    import flash.utils.IExternalizable;

    [Bindable]
    public class ProblemBase implements IExternalizable {

        protected var _message:String;
        protected var _messageNo:int;
        protected var _occurred:Date;

        public function set message(value:String):void {
            _message = value;
        }
        public function get message():String {
            return _message;
        }

        public function set messageNo(value:int):void {
            _messageNo = value;
        }
        public function get messageNo():int {
            return _messageNo;
        }

        public function set occurred(value:Date):void {
            _occurred = value;
        }
        public function get occurred():Date {
            return _occurred;
        }

        public function readExternal(input:IDataInput):void {
            _message = input.readObject() as String;
            _messageNo = input.readObject() as int;
            _occurred = input.readObject() as Date;
        }

        public function writeExternal(output:IDataOutput):void {
            output.writeObject(_message);
            output.writeObject(_messageNo);
            output.writeObject(_occurred);
        }
    }
}